const INTERVAL = 500;
export const createStartIntervalScheduler = (clearInterval, performance, setInterval) => (next) => {
    const start = performance.now();
    let nextTick = start + INTERVAL;
    let end = nextTick + INTERVAL;
    const intervalId = setInterval(() => {
        if (performance.now() >= nextTick) {
            nextTick = end;
            end += INTERVAL;
            next({ end, start: nextTick });
        }
    }, INTERVAL / 10);
    next({ end, start });
    return [() => performance.now() - start, () => clearInterval(intervalId)];
};
//# sourceMappingURL=start-interval-scheduler.js.map